package edu.nyu.scps.dynamic;

import android.app.Activity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;

public class DynamicActivity extends Activity {
	
	//from android-sdks/platforms/android-14/data/res/drawable-hdpi
	final int[] icon = {
		0,	//Make the subscripts start at 1.
		android.R.drawable.ic_menu_add,
		android.R.drawable.ic_menu_delete,
		android.R.drawable.ic_menu_camera,
		android.R.drawable.ic_menu_call,
		android.R.drawable.ic_menu_compass
	};

	int n = 1;	//number of menu items; will increase
	TextView textView;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		textView = (TextView)findViewById(R.id.textView);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		return super.onCreateOptionsMenu(menu);
	}
	
	@Override
	public boolean onPrepareOptionsMenu(Menu menu) {
		final boolean b = super.onPrepareOptionsMenu(menu);
		menu.clear();	//Empty the menu.

		for (int i = 1; i <= n; ++i) {
			final MenuItem menuItem = menu.add(Menu.NONE, Menu.NONE, i, "Item " + i);
			if (i < icon.length) {
				menuItem.setIcon(icon[i]);
			}
			menuItem.setShowAsAction(MenuItem.SHOW_AS_ACTION_IF_ROOM | MenuItem.SHOW_AS_ACTION_WITH_TEXT);
		}
		return b;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		textView.append("\nYou selected " + item.getTitle() + ".");
		++n;
		invalidateOptionsMenu(); //API 11: calls onCreateOptionsMenu and onPrepareOptionsMenu
		return true;	
	}
}